/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/


#include "sortedvector.h"



template<typename T>
int SortedVector<T>::insertSort( QSharedPointer<T> pointer )
{
    int row = -1;

    if ( this->isEmpty() ) {
        this->append( pointer );
        row = 0;
    } else {
        for ( int i = 0; i < this->count(); i++ ) {
            if ( *( *this )[i]  > *pointer ) {
                this->insert( i, pointer );
                row = i;
                break;
            }
        }

        if ( row == -1 ) {
            row = this->count();
            this->append( pointer );
        }

    }

    return row;
}

template<typename T>
int SortedVector<T>::findPosition( QSharedPointer<T> pointer )
{
    int row = -1;

    for ( int i = 0; i < this->count(); i++ ) {
        if ( *( *this )[i]  > *pointer ) {
            row = i;
            break;
        }
    }

    if ( row == -1 ) {
        row = this->count();
    }

    return row;
}

