/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/



#ifndef IOSNOTIFICATIONRECEIVER_H
#define IOSNOTIFICATIONRECEIVER_H

#include <QObject>

class IosNotificationReceiver : public QObject
{
        Q_OBJECT
    public:
        static IosNotificationReceiver *getInstance();

        void sendMessageReceived( QString pServer, QString pRid, QString pName, QString pType );
        void sendSwitchChannelByName( QString pName );

    private:
        IosNotificationReceiver() {}
        IosNotificationReceiver( const IosNotificationReceiver & ) = delete;

        static IosNotificationReceiver *mInstance;


    signals:
        void messageReceived( QString pServer, QString pRid, QString pName, QString pType );
        void switchChannelByName( QString channelName );
};

#endif // IOSNOTIFICATIONRECEIVER_H
