/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/



#ifndef WEBSOCKETLINUX_H
#define WEBSOCKETLINUX_H

#include <QtWebSockets/QtWebSockets>
#include <QAbstractSocket>

#include "websocketabstract.h"


class websocketLinux: public WebsocketAbstract
{
    public:
        websocketLinux( QObject *parent );
        virtual void open( QUrl ) override;
        virtual void close() override;
        virtual void sendTextMessage( QString ) override;
        virtual bool isValid( void ) override;
        virtual bool isDisconnected( void ) override;
        virtual bool isConnecting( void ) override;
        void received( QString );
        void onStatusChanged();
    private:
        QWebSocket mWebsocket;
        void emitConnected();

};

#endif // WEBSOCKETLINUX_H
